
{** @abstract(Fonctions utilisées par l'arbitre du jeu d'échecs.)
  Fonctions utilisées par l'arbitre du jeu d'échecs. }
unit chessgameutils;
{$IFDEF FPC}
{$MODE DELPHI}
{$ENDIF}

interface

type
  TVector = record
    x, y: integer;
  end;
  
const
  cVectors: array[1..16] of TVector = (
    (x:-1; y: 1),
    (x: 1; y: 1),
    (x:-1; y:-1),
    (x: 1; y:-1),
    (x:-1; y: 0),
    (x: 1; y: 0),
    (x: 0; y: 1),
    (x: 0; y:-1),
    (x: 1; y: 2),
    (x: 2; y: 1),
    (x: 2; y:-1),
    (x: 1; y:-2),
    (x:-1; y:-2),
    (x:-2; y:-1),
    (x:-2; y: 1),
    (x:-1; y: 2)
  );

function Sign(const i: integer): integer;
function SquareToStr(const x1, y1: integer): string;
function MoveToStr(const x1, y1, x2, y2: integer): string;
procedure Compute(var x2, y2: integer; const x1, y1, i: integer);

implementation

function Sign(const i: integer): integer;
begin
  if i = 0 then
    result := 0
  else
    if i < 0 then
      result := -1
    else
      result := 1;
end;

function SquareToStr(const x1, y1: integer): string;
begin
  SetLength(result, 2);
  result[1] := Chr(x1 + Ord('a') - 1);
  result[2] := Chr(y1 + Ord('1') - 1);
end;

function MoveToStr(const x1, y1, x2, y2: integer): string;
begin
  SetLength(result, 4);
  result[1] := Chr(x1 + Ord('a') - 1);
  result[2] := Chr(y1 + Ord('1') - 1);
  result[3] := Chr(x2 + Ord('a') - 1);
  result[4] := Chr(y2 + Ord('1') - 1);
end;

procedure Compute(var x2, y2: integer; const x1, y1, i: integer);
begin
  x2 := x1 + cVectors[i].x;
  y2 := y1 + cVectors[i].y;
end;

end.
