
program test1;
{$APPTYPE CONSOLE}
{$IFDEF FPC}
{$MODE DELPHI}
{$ENDIF}

uses
  classes,
  sysutils,
  chessgame;

function ToStr(const aValue: boolean): string;
begin
  result := UpperCase(BoolToStr(aValue, TRUE));
end;

var
  loglist: TStringList;

procedure ToLog(const aText: string);
begin
  loglist.Add(Format('%s %s', [TimeToStr(Now), aText]));
end;

const
  FEN_EXAMPLES: array[1..5] of string = (
    'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1',
    'rnbqkbnr/pppppppp/8/8/4P3/8/PPPP1PPP/RNBQKBNR b KQkq e3 0 1',
    'rnbqkbnr/pp1ppppp/8/2p5/4P3/8/PPPP1PPP/RNBQKBNR w KQkq c6 0 2',
    'rnbqkbnr/pp1ppppp/8/2p5/4P3/5N2/PPPP1PPP/RNBQKB1R b KQkq - 1 2',
    '4k3/8/8/8/8/8/4P3/4K3 w - - 5 39'
  );

var
  game: TGame;
  i: integer;
  
begin
  loglist := TStringList.Create;
  
  for i := Low(FEN_EXAMPLES) to High(FEN_EXAMPLES) do
  begin
    game := TGame.Create(FEN_EXAMPLES[i]);
    //ToLog(Format('%s'#13#10'%s', [{$I %LINE%}, game.CurrentBoardAsText]));
    ToLog(Format('%s %s', [{$I %LINE%}, ToStr(game.ForsythEdwards = FEN_EXAMPLES[i])]));
    game.Free;
  end;
  
  with loglist do
  begin
    SaveToFile(ChangeFileExt({$I %FILE%}, '.log'));
    Free;
  end;
end.
