
program test3;
{$APPTYPE CONSOLE}
{$IFDEF FPC}
{$MODE DELPHI}
{$ENDIF}

uses
  classes,
  sysutils,
  chessgame;

function ToStr(const aValue: boolean): string;
begin
  result := UpperCase(BoolToStr(aValue, TRUE));
end;

var
  loglist: TStringList;

procedure ToLog(const aText: string);
begin
  loglist.Add(Format('%s %s', [TimeToStr(Now), aText]));
end;

function CheckLine(const aLine: string): boolean;
var
  g: TGame;
  i: integer;
  aux: string;
begin
  result := TRUE;
  g := TGame.Create('');
  g.GenerateLegalMoves;
  
  i := 1;
  while (i <= Length(aLine) div 4) and result do
  begin
    aux := Copy(aLine, 4 * i - 3, 4);
    
    if g.IsLegal(aux) then
    begin
      g.PlayMove(aux, cQueen);
      g.GenerateLegalMoves;
    end else
      result := FALSE;
    
    Inc(i);
  end;
  
  g.Free;
end;

const
  OPENING_BOOK = 'book.txt';

var
  i: integer;
  
begin
  loglist := TStringList.Create;
  
  with TStringList.Create do
  begin
    LoadFromFile(OPENING_BOOK);
    for i := 0 to Count - 1 do
      ToLog(Format('%s %0.3d %s', [{$I %LINE%}, i + 1, ToStr(CheckLine(strings[i]))]));
    Free;
  end;
  
  with loglist do
  begin
    SaveToFile(ChangeFileExt({$I %FILE%}, '.log'));
    Free;
  end;
end.
